// $Id: crmngp.js,v 1.3 2009/03/30 21:03:45 seanr Exp $

if (typeof(Drupal) == "undefined" || !Drupal.crmngp) {
  Drupal.crmngp = {};
}

/*
* Submit crmngp forms with ajax
*/
Drupal.crmngp.attachVoteAjax = function() {
  var submitSelect = "input[@value="+ Drupal.settings.crmngp.vote +"]";
  $("form.crmapi-contact-form").each(function() {
    var thisForm = this;
    var options = {
      dataType: "json",
      after: function(data) {
        // Remove previous messages
        $("div.messages").remove();

        // Insert response
        if (data.errors) {
          $(data.errors).insertBefore(thisForm).fadeIn();
        }
        else {
          $(thisForm).hide();
          $(data.statusMsgs).insertBefore(thisForm).fadeIn();
          $(data.response).insertBefore(thisForm);
        }

        // Re-enable the Vote button if there was an error message
        $(submitSelect, thisForm).removeAttr("disabled");

      },
      before: function() {
        // Disable all voting forms for this poll
        var nid = $("input.edit-nid", thisForm).val();
        $("form.crmapi-contact-form").each(function() {
          if ($("input.edit-nid", this).val() == nid) {
            $(submitSelect, this).attr("disabled", "disabled");
          }
        });
      }
    };
    // Tell the server we are passing the form values with ajax and attach the function
    $("input.ajax", thisForm).val(true);
    $(this).ajaxForm(options);
  });
};

Drupal.crmngp.AutoAttach = function() {
  Drupal.crmngp.attachVoteAjax();
};

Drupal.crmngp.handleWriteins = function() {
  $("div.crmngp-form").each(function() {
    var poll = this;
    if ($(".amount", poll).length == 0) {
      // No write-ins in this poll.
      return;
    }
    var ranOnce = false;
    var amount = $(".amount input", poll).val();
    if ($(".amount-choices input[@type=radio]:last, .amount-choices input[@type=checkbox]:last", poll).attr("checked")) {
      $(".amount input", poll).clone().addClass("amount").insertAfter($(".amount-choices input[@type=radio]:last, .amount-choices input[@type=checkbox]:last", poll).parent()).end().parent().parent().remove();
      $(".amount", poll).val(amount);
      ranOnce = true;
    }
    // Toggle display of the write-in text box for radios/checkboxes.
    $(".amount-choices input[@type=radio], .amount-choices input[@type=checkbox]", poll).click(function() {
      var isLast = $(this).val() == $(".amount-choices input[@type=radio]:last, .amount-choices input[@type=checkbox]:last", poll).val();
      var type = $(this).attr("type");
      // The logic here is tricky but intentional.
      if (isLast || type == "radio") {
        var showChoice = isLast && (type == "radio" || $(this).attr("checked"));
        if (!ranOnce && showChoice) {
          // If this is our first time, clone the Drupal-added write-in element
          // and add a new one next to the checkbox, then delete the old one.
          var amount = $(".amount input", poll).val();
          $(".amount input", poll).clone().addClass("amount").insertAfter($(this).parent()).end().parent().parent().remove();
          $(".amount", poll).val(amount);
          ranOnce = true;
        }
        $(".amount", poll).css("display", showChoice ? "inline" : "none");
        if (showChoice) {
          $(".amount", poll)[0].focus();
        }
        /*else {
          $(".amount", poll).val("");
        }*/
      }
    });


    // Toggle display of the write-in text box for select boxes.
    // Fire on change() rather than click(), for Safari compatibility.
    $(".amount-choices select:last", poll).change(function() {
      if (!ranOnce) {
        // If this is our first time, clone the Drupal-added write-in element
        // and add a new one next to the checkbox, then delete the old one.
        $(".amount input", poll).clone().addClass("amount").insertAfter($(this)).end().parent().parent().remove();
        ranOnce = true;
      }
      var showChoice = $(this).val() > 0;
      var alreadyVisible = $(".amount", poll).css("display") == "inline";
      $(".amount", poll).css("display", showChoice ? "inline" : "none");
      if (!showChoice) {
        //$(".amount", poll).val("");
      }
      else if (!alreadyVisible) {
        $(".amount", poll)[0].focus();
      }
    });
  });
};

if (Drupal.jsEnabled) {
  $(document).ready(function(){
    Drupal.crmngp.AutoAttach();
    Drupal.crmngp.handleWriteins();
  }); 
};

$(document).ready(function(){
  var evt = $.browser.msie ? "click" : "change";
  if ($("input[@name='recurring_enable']:checked").val() == 'false') {
    $("div.recurring").hide();
  }
  if ($("#edit-recurring").attr('checked') == false) {
    $("input[@name='recurring_select']").attr("disabled","disabled");
  }
  if ($("input[@name='recurring_select']:checked").val() != 'date') {
    $("#edit-recurring-month").attr("disabled","disabled");
    $("#edit-recurring-year").attr("disabled","disabled");
  }
  
  //console.log($("input[@name='recurring_enable']"));
  
  $("input[@name='recurring_enable']").bind(evt, function(){
    if ($(this).val() == 'true') {
      $("div.recurring").show();
    }
    else {
      $("div.recurring").hide();
    }
  });
  $("#edit-recurring").bind(evt, function(){
    if ($(this).attr('checked')) {
      $("input[@name='recurring_select']").removeAttr("disabled");
    }
    else {
      $("input[@name='recurring_select']").attr("disabled","disabled");
    }
  });
  $("input[@name='recurring_select']").bind(evt, function(){
    if ($(this).val() == 'date') {
      $("#edit-recurring-month").removeAttr("disabled");
      $("#edit-recurring-year").removeAttr("disabled");
    }
    else {
      $("#edit-recurring-month").attr("disabled","disabled");
      $("#edit-recurring-year").attr("disabled","disabled");
    }
  });
});

function popUpWindowHelp(sWindowName, sUrl, iWidth, iHeight) {
	var winLeft = (screen.width - iWidth) / 2;
	var winTop = (screen.height - iHeight - 50) / 2;
	var sWindow = window.open(sUrl, '', 'location=no,status=no,RESIZABLE,width='+iWidth+',height='+iHeight+',toolbar=no,scrollbars=no,left=' + winLeft + ',top=' + winTop);
	sWindow.focus();
	return false;
}

function textareaMaxLength(field, evt, limit) {
  var evt = (evt) ? evt : event;
  var charCode =
    (typeof evt.which != "undefined") ? evt.which :
   ((typeof evt.keyCode != "undefined") ? evt.keyCode : 0);

  if (!(charCode >= 13 && charCode <= 126)) {
    return true;
  }

  return (field.value.length < limit);
}